/*
 * Created on 18 oct. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

import java.awt.Font;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.geom.AffineTransform;
import java.util.Vector;

import gates.*;

/**
 * @author Xavier Dcoret
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public abstract class GraphicalGate {
	static final int m_nb = 10;

	static final int m_r = 15;

	static final int m_s = 3;

	static final int m_h = 10;

	static final int m_o = 2;

	private int x, y;

	private Gate gate;

	Vector gateOnInputs;

	public void setX(int x) {
		this.x = x;
	}

	public void setY(int y) {
		this.y = y;
	}

	public void setXY(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public static int getWidth() {
		return 2 * m_r;
	}

	public abstract GraphicalGate getClone();
	public void highlightInput(Graphics g,int n) {
		g.translate(getX(),getY());
		switch (gate.getNbInputs()) {
		case 2:
			switch (n) {
			case 0:
				g.fillOval(-m_r/2-2*m_o,-m_r-m_h-2*m_o,4*m_o,4*m_o);
				break;
			case 1:
				g.fillOval(+m_r/2-2*m_o,-m_r-m_h-2*m_o,4*m_o,4*m_o);
				break;
			}
			break;
		case 1:
			switch (n) {
			case 0: 
				g.fillOval(-2*m_o,-m_r-m_h-2*m_o,4*m_o,4*m_o);
				break;
			}
			break;
		}			
		g.translate(-getX(),-getY());
	}
	public void draw(Graphics g) {
		g.translate(getX(),getY());
		// Draw the inputs
		switch (gate.getNbInputs()) {
		case 2:
			g.drawLine(-m_r/2,-m_r,-m_r/2,-m_r-m_h);
			g.drawLine(+m_r/2,-m_r,+m_r/2,-m_r-m_h);
			g.fillOval(-m_r/2-m_o,-m_r-m_h-m_o,2*m_o,2*m_o);
			g.fillOval(+m_r/2-m_o,-m_r-m_h-m_o,2*m_o,2*m_o);
			break;
		case 1:
			g.drawLine(0,-m_r,0,-m_r-m_h);
			g.fillOval(-m_o,-m_r-m_h-m_o,2*m_o,2*m_o);
			break;
		}	
		// Draw the output
		g.drawLine(0,m_r,0,m_r+m_h);
		g.fillOval(0-m_o,m_r+m_h-m_o,2*m_o,2*m_o);
		// Draw the text
		AffineTransform transf = new AffineTransform();
		double textW = g.getFontMetrics().getStringBounds(getText(),g).getWidth();
		transf.scale((2*m_r-2*m_s)/textW,(2*m_r-2*m_s)/textW);
		Font f = g.getFont();
		g.setFont(g.getFont().deriveFont(transf));
		g.setFont(f);
		g.drawString(getText(),-(int) textW/2,0);
		// Draw body
		g.drawPolygon(getBody());
		
		g.translate(-getX(),-getY());
		// Draw the connections to other graphical gates
		for (int i=0;i<gateOnInputs.size();++i)
		if (gateOnInputs.elementAt(i) != null) {
			try {
				GraphicalGate gOnI = (GraphicalGate) gateOnInputs.elementAt(i);
				Point a = getInputPos(i);
				Point b = gOnI.getOutputPos();
				g.drawLine((int) a.getX(), (int) a.getY(), (int) b.getX(), (int) b.getY());
			} catch (Exception e) {
			}
		}
	}
	protected abstract String getText();
	protected abstract Polygon getBody();
	public Point getInputPos(int n){
		switch (gate.getNbInputs()) {
		case 2:
			switch (n) {
			case 0: return new Point(getX()+(-m_r/2),getY()+(-m_r-m_h));
			case 1: return new Point(getX()+(+m_r/2),getY()+(-m_r-m_h));
			}
			break;
		case 1:
			switch (n) {
			case 0: return new Point(getX(),getY()+(-m_r-m_h));
			}
			break;
		}
		return null;
	}
	public Point getOutputPos() {
		return new Point(getX(),getY()+(m_r+m_h));
	}
	public GraphicalGate(int x, int y, Gate g) {
		this.x = x;
		this.y = y;
		this.gate = g;
		gateOnInputs = new Vector();
		for (int i=0;i<gate.getNbInputs();++i) gateOnInputs.addElement(null); 
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	public Gate getGate() {
		return gate;
	}

	public boolean isBodyClicked(int x, int y) {
		return getBody().contains(x-getX(),y-getY());
	}
	
	public void reactToDoubleClick() {
	}

	public void highlightOutput(Graphics g) {
		g.translate(getX(),getY());
		g.fillOval(0-2*m_o,m_r+m_h-2*m_o,4*m_o,4*m_o);
		g.translate(-getX(),-getY());
	}
}